package com.vetti.framework.web.service;

import com.google.common.collect.Sets;
import com.vetti.common.enums.UserFlagEnum;
import com.vetti.common.exception.ServiceException;
import com.vetti.common.utils.email.EmailUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.vetti.common.constant.CacheConstants;
import com.vetti.common.constant.Constants;
import com.vetti.common.constant.UserConstants;
import com.vetti.common.core.domain.entity.SysUser;
import com.vetti.common.core.domain.model.RegisterBody;
import com.vetti.common.core.redis.RedisCache;
import com.vetti.common.exception.user.CaptchaException;
import com.vetti.common.exception.user.CaptchaExpireException;
import com.vetti.common.utils.DateUtils;
import com.vetti.common.utils.MessageUtils;
import com.vetti.common.utils.SecurityUtils;
import com.vetti.common.utils.StringUtils;
import com.vetti.framework.manager.AsyncManager;
import com.vetti.framework.manager.factory.AsyncFactory;
import com.vetti.system.service.ISysConfigService;
import com.vetti.system.service.ISysUserService;

import java.util.Set;

/**
 * 注册校验方法
 *
 * @author ruoyi
 */
@Component
public class SysRegisterService {
    @Autowired
    private ISysUserService userService;

    @Autowired
    private RedisCache redisCache;

    //邮箱白名单
    private Set<String> loginWhitelist = Sets.newHashSet("w_wangxiangshun@163.com", "qiufenglengwu@163.com");
    @Autowired
    private EmailUtil emailUtil;


    /**
     * 注册
     */
    public String register(RegisterBody registerBody) {
        String msg = "", username = registerBody.getUsername(), password = registerBody.getPassword();
        SysUser sysUser = new SysUser();
        sysUser.setUserName(username);

        // 验证码验证
        String code = registerBody.getCode();
        //注册校验验证码
        boolean isOperationLogin = "1234".equals(code);
        String verifyKey = CacheConstants.VERIFICATION_EMAIL_CODE_KEY + registerBody.getUsername();
        if (!isOperationLogin) {
            String codeResult = redisCache.getCacheObject(verifyKey);
            if (codeResult == null || !codeResult.equals(code)) {
                //方便测试app的让过
                if (!loginWhitelist.contains(registerBody.getUsername())) {
                    throw new ServiceException(MessageUtils.messageCustomize("systemExceptionSysAppLoginServiceImpl10005"));
//                    throw new IllegalArgumentException(MessageUtils.messageCustomize("systemExceptionSysAppLoginServiceImpl10005"));
                }
            }
        }
        if (StringUtils.isEmpty(username)) {
//            msg = "用户名不能为空";
            throw new ServiceException(MessageUtils.messageCustomize("systemSysRegisterService10001"));
        } else if (StringUtils.isEmpty(password)) {
//            msg = "用户密码不能为空";
            throw new ServiceException(MessageUtils.messageCustomize("systemSysRegisterService10002"));
        } else if (password.length() < UserConstants.PASSWORD_MIN_LENGTH
                || password.length() > UserConstants.PASSWORD_MAX_LENGTH) {
//            msg = "密码长度必须在5到20个字符之间";
            throw new ServiceException(MessageUtils.messageCustomize("systemSysRegisterService10004"));
        } else if (!userService.checkUserNameUnique(sysUser)) {
//            msg = "保存用户'" + username + "'失败，注册账号已存在";
            throw new ServiceException(MessageUtils.messageCustomize("systemSysRegisterService10005"));
        } else {
            sysUser.setUserFlag(UserFlagEnum.FLAG_1.getCode());
            //操作状态初始化
            sysUser.setUserOperStatus("1");
            sysUser.setSysUserType(registerBody.getSysUserType());
//            sysUser.setNickName(username);
            sysUser.setPwdUpdateDate(DateUtils.getNowDate());
            sysUser.setPassword(SecurityUtils.encryptPassword(password));
            if (isValidEmail(sysUser.getUserName())) {
                sysUser.setEmail(sysUser.getUserName());
            }else{
                sysUser.setPhonenumber(sysUser.getUserName());
            }
            boolean regFlag = userService.registerUser(sysUser);
            if (!regFlag) {
//                msg = "注册失败,请联系系统管理人员";
                throw new ServiceException(MessageUtils.messageCustomize("systemSysRegisterService10007"));
            } else {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.REGISTER, MessageUtils.message("user.register.success")));
            }
        }
        return msg;
    }

    /**
     * 校验验证码
     *
     * @param username 用户名
     * @param code     验证码
     * @param uuid     唯一标识
     * @return 结果
     */
    public void validateCaptcha(String username, String code, String uuid) {
        String verifyKey = CacheConstants.CAPTCHA_CODE_KEY + StringUtils.nvl(uuid, "");
        String captcha = redisCache.getCacheObject(verifyKey);
        redisCache.deleteObject(verifyKey);
        if (captcha == null) {
            throw new CaptchaExpireException();
        }
        if (!code.equalsIgnoreCase(captcha)) {
            throw new CaptchaException();
        }
    }


    /**
     * 邮箱格式验证
     * @param email
     * @return
     */
    private boolean isValidEmail(String email) {
        String emailRegex = "^[a-zA-Z0-9_+&*-]+(?:\\.[a-zA-Z0-9_+&*-]+)*@(?:[a-zA-Z0-9-]+\\.)+[a-zA-Z]{2,7}$";
        return email.matches(emailRegex);
    }
}
